/* Define if your system has a sane BSD-licensed libedit */
#undef HAVE_LIBEDIT

/* Define if your system has the GPL-infected libreadline */
#undef HAVE_LIBREADLINE

/* Define if tar does not understand unzipping */
#undef HAVE_BROKEN_TAR

/* Define to the path where the gzip program can be found */
#undef _PATH_GZIP

/* Define to the path where the sh program can be found */
#undef _PATH_SH

/* Define to the path where the tar program can be found */
#undef _PATH_TAR

/* Define if your raw sockets have arguments in host order as in BSD.  */
#undef BSD_RAWSOCK_ORDER

/* Define if your system knows about struct sockaddr_storage */
#undef HAVE_SOCKADDR_STORAGE
#ifndef HAVE_SOCKADDR_STORAGE
#define HAVE_SOCKADDR_STORAGE
struct sockaddr_storage {
	u_char iamasuckyoperatingsystem[128];
};
#endif

/* Define to int if your system does not know about sa_family_t */
#undef sa_family_t

/* Define to int if your system does not know about socklen_t */
#undef socklen_t

/* Define to `unsigned long long' if <sys/types.h> doesn't define.  */
#undef u_int64_t

/* Define to `unsigned int' if <sys/types.h> doesn't define.  */
#undef u_int32_t

/* Define to `unsigned short' if <sys/types.h> doesn't define.  */
#undef u_int16_t

/* Define to `unsigned char' if <sys/types.h> doesn't define.  */
#undef u_int8_t

/* Undefine if <netdb.h> contains this, otherwise define to 1 */
#undef NI_NUMERICHOST

/* Undefine if struct socketaddr_un does not contain sun_len */
#undef HAVE_SUN_LEN

/* Take care of getaddrinfo */
#undef HAVE_STRUCT_ADDRINFO
#ifndef HAVE_STRUCT_ADDRINFO
#include "getaddrinfo.h"
#include "getnameinfo.h"
#endif /* !HAVE_STRUCT_ADDRINFO */

#ifndef HAVE_GETADDRINFO
int getaddrinfo(const char *hostname, const char *servname, 
                const struct addrinfo *hints, struct addrinfo **res);
#endif /* !HAVE_GETADDRINFO */

/* Define if timeradd is defined in <sys/time.h> */
#undef HAVE_TIMERADD
#ifndef HAVE_TIMERADD
#define timeradd(tvp, uvp, vvp)                                         \
        do {                                                            \
                (vvp)->tv_sec = (tvp)->tv_sec + (uvp)->tv_sec;          \
                (vvp)->tv_usec = (tvp)->tv_usec + (uvp)->tv_usec;       \
                if ((vvp)->tv_usec >= 1000000) {                        \
                        (vvp)->tv_sec++;                                \
                        (vvp)->tv_usec -= 1000000;                      \
                }                                                       \
        } while (0)
#define	timersub(tvp, uvp, vvp)						\
	do {								\
		(vvp)->tv_sec = (tvp)->tv_sec - (uvp)->tv_sec;		\
		(vvp)->tv_usec = (tvp)->tv_usec - (uvp)->tv_usec;	\
		if ((vvp)->tv_usec < 0) {				\
			(vvp)->tv_sec--;				\
			(vvp)->tv_usec += 1000000;			\
		}							\
	} while (0)
#endif /* !HAVE_TIMERADD */

/* Define if dirent has d_type */
#undef HAVE_GOOD_DIRENT

/* Define if fd_mask is defined in <sys/select.h> */
#undef HAVE_FDMASK_IN_SELECT

/* Define if you have the <db.h> header file.  */
#undef HAVE_DB_H

/* Define if you have the <db_185.h> header file.  */
#undef HAVE_DB_185_H

/* Take care of getaddrinfo */
#undef HAVE_STRUCT_ADDRINFO
#ifndef HAVE_STRUCT_ADDRINFO
#include "getaddrinfo.h"
#endif /* !HAVE_STRUCT_ADDRINFO */

#ifndef HAVE_GETADDRINFO
int getaddrinfo(const char *hostname, const char *servname, 
                const struct addrinfo *hints, struct addrinfo **res);
#endif /* !HAVE_GETADDRINFO */

@BOTTOM@

/* Prototypes for missing functions */
#ifndef HAVE_STRLCAT
size_t	 strlcat(char *, const char *, size_t);
#endif

#ifndef HAVE_STRLCPY
size_t	 strlcpy(char *, const char *, size_t);
#endif

#ifndef HAVE_STRSEP
char	*strsep(char **, const char *);
#endif

#ifndef HAVE_BASENAME
char	*basename(const char *);
char	*dirname(const char *);
#endif

#ifndef HAVE_ARC4RANDOM
u_int32_t arc4random(void);
#endif
