#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>

#include "config.h"

/*
 * For those poor operating systems, that do not have a PRNG in their
 * libc.  Unfortunately, for this application, I need real randomness.
 */

u_int32_t
arc4random(void)
{
	static int init;

	if (!init) {
		struct timeval tv;
		u_int value;

		gettimeofday(&tv, NULL);
		value = tv.tv_sec ^ tv.tv_usec;
		value ^= (getppid() << 16) | getpid();
		
		init = 1;
		srandom(value);
	}
	return (random());
}
